﻿using System;
using System.Globalization;
using System.Windows.Data;

namespace TestProject
{
    /// <summary>
    /// 사람명 변환자
    /// </summary>
    public class PersonNameConverter : IMultiValueConverter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 변환하기 - Convert(sourceValueArray, targetType, parameter, cultureInfo)

        /// <summary>
        /// 변환하기
        /// </summary>
        /// <param name="sourceValueArray">소스 값 배열</param>
        /// <param name="targetType">타겟 타입</param>
        /// <param name="parameter">매개 변수</param>
        /// <param name="cultureInfo">문화 정보</param>
        /// <returns>변환 값</returns>
        public object Convert(object[] sourceValueArray, Type targetType, object parameter, CultureInfo cultureInfo)
        {
            string name;

            switch((string)parameter)
            {
                case "FormatLastFirst" :

                    name = sourceValueArray[1] + ", " + sourceValueArray[0];

                    break;

                default :

                    name = sourceValueArray[0] + " " + sourceValueArray[1];

                    break;
            }

            return name;
        }

        #endregion
        #region 역변환하기 - ConvertBack(sourceValue, targetTypeArray, parameter, cultureInfo)

        /// <summary>
        /// 역변환하기
        /// </summary>
        /// <param name="sourceValue">소스 값</param>
        /// <param name="targetTypeArray">타겟 타입 배열</param>
        /// <param name="parameter">매개 변수</param>
        /// <param name="cultureInfo">문화 정보</param>
        /// <returns>역변환 값</returns>
        public object[] ConvertBack(object sourceValue, Type[] targetTypeArray, object parameter, CultureInfo cultureInfo)
        {
            string[] targetValueArray = ((string) sourceValue).Split(' ');

            return targetValueArray;
        }

        #endregion
    }
}